# 如何科学的提取组件
提取组件的目的：
> 1）能够把页面抽象成多个相对独立的模块;
> 2）实现代码重用，提高开发效率和代码质量，使得代码易于维护

#### 1. 不要Copy 组件

咨询原有组件，是否可修改，可重用。尽量不要原封不动copy过来，改一点点。

#### 2. 外部调用组件内部的方法,尽量不要通过ref调用内部方法，不可控

最好是调用组件自身用到的方法。否则组件若删除某个自身未使用的方法，可能会导致出错。
切忌为了外部调用，而增加单独的方法。

#### 3. 组件不是越多越好，增加一个组件，系统的复杂度也会随之增加

一般情况，系统中一个文件一个页面，最为妥当。组件只是在不得以（1. 页面过于复杂;2. 提取公用组件）的情况下，才提取，不要为了组件化而组件化，这样只能起到画蛇添足的作用。

#### 4. 不用的属性删除掉，做的精品，不是残次品

系统中copy没有错，但是不要很粗暴的copy，很多上一个组件用到的，对于新组件无用的属性、方法都没有删掉。显得很粗糙。

#### 5. 不要把utils用作业务，它是工具包

分工要明确。

#### 6. 思考代码目的，独立思考

1） 怎么做
2） 为什么这么做
3） 还可以更好吗

#### 7. 高内聚低耦合

这个原则，亘古不变。
一个好的组件，应该是独立的，零附作用的。

```
其它建议：

1. Modal 最好不要做成组件
    复用性不好，等到要复用时，显得束手束脚。

2. 属性名称尽量易理解、概括、通用
```